package com.sample;

import java.util.List;

import org.drools.runtime.StatefulKnowledgeSession;
import org.drools.runtime.process.ProcessInstance;
import org.jbpm.process.workitem.wsht.SyncWSHumanTaskHandler;
import org.jbpm.task.TaskService;
import org.jbpm.task.query.TaskSummary;
import org.jbpm.task.service.local.LocalTaskService;
import org.jbpm.test.JbpmJUnitTestCase;
import org.junit.Test;

/**
 * This is a sample file to launch a process.
 */
public class ProcessTest extends JbpmJUnitTestCase {

	public ProcessTest() {
		super(true);
		setPersistence(true);
	}

	@Test
	public void testProcess() {
		StatefulKnowledgeSession ksession = createKnowledgeSession("defaultPackage.commatest.bpmn2");
		TaskService taskService = getTaskServiceAndRegisterHumanTaskHandler(ksession);
		
		ProcessInstance processInstance = ksession.startProcess("defaultPackage.commatest");
		
		// let john execute Task 1
		List<TaskSummary> list = taskService.getTasksAssignedAsPotentialOwner("john", "en-UK");
		TaskSummary task = list.get(0);
		System.out.println("John is executing task " + task.getName());
		System.out.println("Task Comment : " + task.getDescription());
		taskService.start(task.getId(), "john");
		taskService.complete(task.getId(), "john", null);
		
		ksession.dispose();
	}
	
    private TaskService getTaskServiceAndRegisterHumanTaskHandler(
            StatefulKnowledgeSession ksession) {
        LocalTaskService localTaskService = new LocalTaskService(getService());

        SyncWSHumanTaskHandler humanTaskHandler = new SyncWSHumanTaskHandler(
                localTaskService, ksession);
        humanTaskHandler.setLocal(true);
        humanTaskHandler.connect();
        ksession.getWorkItemManager().registerWorkItemHandler("Human Task",
                humanTaskHandler);
        return localTaskService;
    }
	
}